/**
 ******************************************************************************
 *
 * @file       uavobjecttemplate.cpp
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Template for an uavobject in java
 *             This is a autogenerated file!! Do not modify and expect a result.
 *             Settings for the @ref FixedWingPathFollowerModule
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package org.openpilot.uavtalk.uavobjects;

import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

import org.openpilot.uavtalk.UAVObjectManager;
import org.openpilot.uavtalk.UAVObject;
import org.openpilot.uavtalk.UAVDataObject;
import org.openpilot.uavtalk.UAVObjectField;

/**
Settings for the @ref FixedWingPathFollowerModule

generated from fixedwingpathfollowersettings.xml
 **/
public class FixedWingPathFollowerSettings extends UAVDataObject {

	public FixedWingPathFollowerSettings() {
		super(OBJID, ISSINGLEINST, ISSETTINGS, NAME);
		
		List<UAVObjectField> fields = new ArrayList<UAVObjectField>();
		

		List<String> AirSpeedMaxElemNames = new ArrayList<String>();
		AirSpeedMaxElemNames.add("0");
		fields.add( new UAVObjectField("AirSpeedMax", "m/s", UAVObjectField.FieldType.FLOAT32, AirSpeedMaxElemNames, null) );

		List<String> AirSpeedMinElemNames = new ArrayList<String>();
		AirSpeedMinElemNames.add("0");
		fields.add( new UAVObjectField("AirSpeedMin", "m/s", UAVObjectField.FieldType.FLOAT32, AirSpeedMinElemNames, null) );

		List<String> VerticalVelMaxElemNames = new ArrayList<String>();
		VerticalVelMaxElemNames.add("0");
		fields.add( new UAVObjectField("VerticalVelMax", "m/s", UAVObjectField.FieldType.FLOAT32, VerticalVelMaxElemNames, null) );

		List<String> HorizontalPosPElemNames = new ArrayList<String>();
		HorizontalPosPElemNames.add("0");
		fields.add( new UAVObjectField("HorizontalPosP", "(m/s)/m", UAVObjectField.FieldType.FLOAT32, HorizontalPosPElemNames, null) );

		List<String> VerticalPosPElemNames = new ArrayList<String>();
		VerticalPosPElemNames.add("0");
		fields.add( new UAVObjectField("VerticalPosP", "(m/s)/m", UAVObjectField.FieldType.FLOAT32, VerticalPosPElemNames, null) );

		List<String> CoursePIElemNames = new ArrayList<String>();
		CoursePIElemNames.add("Kp");
		CoursePIElemNames.add("Ki");
		CoursePIElemNames.add("ILimit");
		fields.add( new UAVObjectField("CoursePI", "deg/deg", UAVObjectField.FieldType.FLOAT32, CoursePIElemNames, null) );

		List<String> SpeedPElemNames = new ArrayList<String>();
		SpeedPElemNames.add("Kp");
		SpeedPElemNames.add("Max");
		fields.add( new UAVObjectField("SpeedP", "(m/s^2) / ((m/s)/(m/s)", UAVObjectField.FieldType.FLOAT32, SpeedPElemNames, null) );

		List<String> AccelPIElemNames = new ArrayList<String>();
		AccelPIElemNames.add("Kp");
		AccelPIElemNames.add("Ki");
		AccelPIElemNames.add("ILimit");
		fields.add( new UAVObjectField("AccelPI", "deg / (m/s^2)", UAVObjectField.FieldType.FLOAT32, AccelPIElemNames, null) );

		List<String> VerticalToPitchCrossFeedElemNames = new ArrayList<String>();
		VerticalToPitchCrossFeedElemNames.add("Kp");
		VerticalToPitchCrossFeedElemNames.add("Max");
		fields.add( new UAVObjectField("VerticalToPitchCrossFeed", "deg / ((m/s)/(m/s))", UAVObjectField.FieldType.FLOAT32, VerticalToPitchCrossFeedElemNames, null) );

		List<String> AirspeedToVerticalCrossFeedElemNames = new ArrayList<String>();
		AirspeedToVerticalCrossFeedElemNames.add("Kp");
		AirspeedToVerticalCrossFeedElemNames.add("Max");
		fields.add( new UAVObjectField("AirspeedToVerticalCrossFeed", "(m/s) / ((m/s)/(m/s))", UAVObjectField.FieldType.FLOAT32, AirspeedToVerticalCrossFeedElemNames, null) );

		List<String> PowerPIElemNames = new ArrayList<String>();
		PowerPIElemNames.add("Kp");
		PowerPIElemNames.add("Ki");
		PowerPIElemNames.add("ILimit");
		fields.add( new UAVObjectField("PowerPI", "1/(m/s)", UAVObjectField.FieldType.FLOAT32, PowerPIElemNames, null) );

		List<String> RollLimitElemNames = new ArrayList<String>();
		RollLimitElemNames.add("Min");
		RollLimitElemNames.add("Neutral");
		RollLimitElemNames.add("Max");
		fields.add( new UAVObjectField("RollLimit", "deg", UAVObjectField.FieldType.FLOAT32, RollLimitElemNames, null) );

		List<String> PitchLimitElemNames = new ArrayList<String>();
		PitchLimitElemNames.add("Min");
		PitchLimitElemNames.add("Neutral");
		PitchLimitElemNames.add("Max");
		fields.add( new UAVObjectField("PitchLimit", "deg", UAVObjectField.FieldType.FLOAT32, PitchLimitElemNames, null) );

		List<String> ThrottleLimitElemNames = new ArrayList<String>();
		ThrottleLimitElemNames.add("Min");
		ThrottleLimitElemNames.add("Neutral");
		ThrottleLimitElemNames.add("Max");
		fields.add( new UAVObjectField("ThrottleLimit", "", UAVObjectField.FieldType.FLOAT32, ThrottleLimitElemNames, null) );

		List<String> UpdatePeriodElemNames = new ArrayList<String>();
		UpdatePeriodElemNames.add("0");
		fields.add( new UAVObjectField("UpdatePeriod", "ms", UAVObjectField.FieldType.INT32, UpdatePeriodElemNames, null) );


		// Compute the number of bytes for this object
		int numBytes = 0;
		ListIterator<UAVObjectField> li = fields.listIterator();
		while(li.hasNext()) {
			numBytes += li.next().getNumBytes();
		}
		NUMBYTES = numBytes;

		// Initialize object
		initializeFields(fields, ByteBuffer.allocate(NUMBYTES), NUMBYTES);
		// Set the default field values
		setDefaultFieldValues();
		// Set the object description
		setDescription(DESCRIPTION);
	}

	/**
	 * Create a Metadata object filled with default values for this object
	 * @return Metadata object with default values
	 */
	public Metadata getDefaultMetadata() {
		UAVObject.Metadata metadata = new UAVObject.Metadata();
    	metadata.flags =
		    UAVObject.Metadata.AccessModeNum(UAVObject.AccessMode.ACCESS_READWRITE) << UAVOBJ_ACCESS_SHIFT |
		    UAVObject.Metadata.AccessModeNum(UAVObject.AccessMode.ACCESS_READWRITE) << UAVOBJ_GCS_ACCESS_SHIFT |
		    1 << UAVOBJ_TELEMETRY_ACKED_SHIFT |
		    1 << UAVOBJ_GCS_TELEMETRY_ACKED_SHIFT |
		    UAVObject.Metadata.UpdateModeNum(UAVObject.UpdateMode.UPDATEMODE_ONCHANGE) << UAVOBJ_TELEMETRY_UPDATE_MODE_SHIFT |
		    UAVObject.Metadata.UpdateModeNum(UAVObject.UpdateMode.UPDATEMODE_ONCHANGE) << UAVOBJ_GCS_TELEMETRY_UPDATE_MODE_SHIFT;
    	metadata.flightTelemetryUpdatePeriod = 0;
    	metadata.gcsTelemetryUpdatePeriod = 0;
    	metadata.loggingUpdatePeriod = 0;
 
		return metadata;
	}

	/**
	 * Initialize object fields with the default values.
	 * If a default value is not specified the object fields
	 * will be initialized to zero.
	 */
	public void setDefaultFieldValues()
	{
		getField("AirSpeedMax").setValue(15);
		getField("AirSpeedMin").setValue(10);
		getField("VerticalVelMax").setValue(10);
		getField("HorizontalPosP").setValue(0.05);
		getField("VerticalPosP").setValue(0.05);
		getField("CoursePI").setValue(0.2,0);
		getField("CoursePI").setValue(0,1);
		getField("CoursePI").setValue(0,2);
		getField("SpeedP").setValue(10,0);
		getField("SpeedP").setValue(10,1);
		getField("AccelPI").setValue(1.5,0);
		getField("AccelPI").setValue(1.5,1);
		getField("AccelPI").setValue(20,2);
		getField("VerticalToPitchCrossFeed").setValue(50,0);
		getField("VerticalToPitchCrossFeed").setValue(5,1);
		getField("AirspeedToVerticalCrossFeed").setValue(100,0);
		getField("AirspeedToVerticalCrossFeed").setValue(100,1);
		getField("PowerPI").setValue(0.01,0);
		getField("PowerPI").setValue(0.01,1);
		getField("PowerPI").setValue(0.8,2);
		getField("RollLimit").setValue(-35,0);
		getField("RollLimit").setValue(0,1);
		getField("RollLimit").setValue(35,2);
		getField("PitchLimit").setValue(-10,0);
		getField("PitchLimit").setValue(5,1);
		getField("PitchLimit").setValue(20,2);
		getField("ThrottleLimit").setValue(0.1,0);
		getField("ThrottleLimit").setValue(0.5,1);
		getField("ThrottleLimit").setValue(0.9,2);
		getField("UpdatePeriod").setValue(100);

	}

	/**
	 * Create a clone of this object, a new instance ID must be specified.
	 * Do not use this function directly to create new instances, the
	 * UAVObjectManager should be used instead.
	 */
	public UAVDataObject clone(long instID) {
		// TODO: Need to get specific instance to clone
		try {
			FixedWingPathFollowerSettings obj = new FixedWingPathFollowerSettings();
			obj.initialize(instID, this.getMetaObject());
			return obj;
		} catch  (Exception e) {
			return null;
		}
	}

	/**
	 * Static function to retrieve an instance of the object.
	 */
	public FixedWingPathFollowerSettings GetInstance(UAVObjectManager objMngr, long instID)
	{
	    return (FixedWingPathFollowerSettings)(objMngr.getObject(FixedWingPathFollowerSettings.OBJID, instID));
	}

	// Constants
	protected static final long OBJID = 0x8A3F1E02l;
	protected static final String NAME = "FixedWingPathFollowerSettings";
	protected static String DESCRIPTION = "Settings for the @ref FixedWingPathFollowerModule";
	protected static final boolean ISSINGLEINST = 1 > 0;
	protected static final boolean ISSETTINGS = 1 > 0;
	protected static int NUMBYTES = 0;


}
