/**
 ******************************************************************************
 *
 * @file       configcamerastabilizationtwidget.h
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2011.
 * @addtogroup GCSPlugins GCS Plugins
 * @{
 * @addtogroup ConfigPlugin Config Plugin
 * @{
 * @brief Telemetry configuration panel
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef CONFIGCAMERASTABILIZATIONWIDGET_H
#define CONFIGCAMERASTABILIZATIONWIDGET_H

#include "ui_camerastabilization.h"
#include "../uavobjectwidgetutils/configtaskwidget.h"
#include "extensionsystem/pluginmanager.h"
#include "uavobjectmanager.h"
#include "uavobject.h"
#include "camerastabsettings.h"

class ConfigCameraStabilizationWidget: public ConfigTaskWidget
{
    Q_OBJECT

public:
    ConfigCameraStabilizationWidget(QWidget *parent = 0);
    ~ConfigCameraStabilizationWidget();
private:
    Ui_CameraStabilizationWidget *m_camerastabilization;
    virtual void enableControls(bool enable);
    void refreshUIValues(CameraStabSettings::DataFields &cameraStabData);

private slots:
    void openHelp();
    void resetToDefaults();
    void applySettings();
    void saveSettings();
    void refreshValues();

protected:
    void connectUpdates();
    void disconnectUpdates();
};

#endif // CONFIGCAMERASTABILIZATIONWIDGET_H
